const express = require("express")
const fs = require("fs")
const app = express()

exports.setup = function(data, port) {
  if (data.constructor.name == "Object") {
    data = data
  } else if (data.constructor.name == "String") {
    if (fs.existsSync(data) && data.endsWith(".json")) {
      data = JSON.parse(fs.readFileSync(data))
    } else {
      console.error("Error", "Invalid data")
      return;
    }
  } else {
    console.error("Error", "Invalid data")
    return;
  }
  app.use((req, res) => {
    function cmd(content) {
      let ip = req.ip.split(":")[3]
      return content.replaceAll("$ip", ip).replaceAll("$path", req.path)
    }
    function use(name) {
      if (data[name]["type"] == "content") {
        if (!!data[req.path]["cmd"] && data[req.path]["cmd"] == "true") {
          data[req.path]["value"] = cmd(data[req.path]["value"])
        }
        res.send(data[name]["value"])
        if (!!data[name]["status"] && data[name]["status"].constructor.name == 'Number'){
          res.status(data[name]["status"])
        }
      } else if (data[name]["type"] == "file") {
        if (fs.existsSync(data[name]["value"])) {
          req.sendFile(__dirname + data[name]["value"])
          if (!!data[name]["status"] && data[name]["status"].constructor.name == 'Number'){
          res.status(data[name]["status"])
        }
        } else {
          console.error("Error", "file not exist")
          return;
        }
      } else if (data[name]["type"] == "link") {
        res.redirect(data[name]["value"])
      }
    }
    if (!!data[req.path]) {
      if (!!data[req.path]["type"] && !!data[req.path]["value"]) {
        use(req.path)
      }
    } else if (!!data["404"]) {
      if (!!data[req.path]["type"] && !!data[req.path]["value"]) {
        use(req.path)
      }
    }
    if (!!data[req.path]["console"]) {
      if (!!data[req.path]["cmd"] && data[req.path]["cmd"] == "true") {
        data[req.path]["console"] = cmd(data[req.path]["console"])
      }
      console.log(data[req.path]["console"])
    }
  })
  
  if (!!port) {
    app.listen(port)
  }
}

exports.port = function(port) {
  app.listen(port)
}

exports.static = function(folder) {
  app.use(express.static(folder))
}